% !TEX root = main.tex
\newpage
\appendix



\section{Details on Small-world Inter-clique Topology}
\label{app:small_world}

 We present a more detailed and precise explanation of the algorithm to establish a small-world
 inter-clique topology (Algorithm~\ref{Algorithm:Smallworld}). Algorithm~\ref{Algorithm:Smallworld} instantiates the function 
\texttt{inter} with a
small-world inter-clique topology as described in Section~\ref{section:interclique-topologies}. It adds a
linear number of inter-clique edges by first arranging cliques on a ring. It then adds a logarithmic number of ``finger'' edges to other cliques on the ring chosen such that there is a constant number of edges added per set, on sets that are exponentially bigger the further away on the ring. ``Finger'' edges are added symmetrically on both sides of the ring to the cliques in each set that are closest to a given set. ``Finger`` edges are added for each clique on the ring, therefore adding in total a linear-logarithmic number of edges.

\begin{figure}[h]
   \hrule
   \begin{algorithmic}[1]
        \State \textbf{Require:} set of cliques $DC$ (set of set of nodes)
        \State ~~size of neighborhood $ns$ (default 2)
        \State ~~function $\textit{least\_edges}(S, E)$ that returns one of the nodes in $S$ with the least number of edges in $E$
        \State $E \leftarrow \emptyset$ \Comment{Set of Edges}
        \State $L \leftarrow [ C~\text{for}~C \in DC ]$ \Comment{Arrange cliques in a list}
        \For{$i \in \{1,\dots,\#DC\}$} % \Comment{For every clique}
%          %\State ~\Comment{For sets of cliques exponentially further away from $i$}
          \For{$\textit{offset} \in \{ 2^x~\text{for}~x~\in \{ 0, \dots, \lceil \log_2(\#DC) \rceil \} \}$} 
%             \State \Comment{Pick the $ns$ closest}
             \For{$k \in \{0,\dots,ns-1\}$}
%                 \State \Comment{Add inter-clique connections in both directions}
                 \State $n \leftarrow \textit{least\_edges}(L_i, E)$
                 \State $m \leftarrow \textit{least\_edges}(L_{(i+\textit{offset}+k) \% \#DC}, E)$ %\Comment{clockwise in ring}
                 \State $E \leftarrow E \cup \{ \{n,m\} \}$
                 \State $n \leftarrow \textit{least\_edges}(L_i, E)$
                 \State $m \leftarrow \textit{least\_edges}(L_{(i-\textit{offset}-k)\% \#DC} , E)$ %\Comment{counter-clockwise in ring}
                 \State $E \leftarrow E \cup \{ \{n,m\} \}$
             \EndFor
           \EndFor
        \EndFor
         \State \Return E
   \end{algorithmic}
   \hrule
      \caption{$\textit{smallworld}(DC)$:  adds $O(\# N \log(\# N))$ edges}
   \label{Algorithm:Smallworld}
\end{figure}

Algorithm~\ref{Algorithm:Smallworld}  expects a set of cliques $DC$, previously computed by 
Algorithm~\ref{Algorithm:greedy-swap}; a size of neighborhood $ns$,
which is the number of finger edges to add per set of cliques, and a function 
\textit{least\_edges}, which given a set of nodes $S$ and an existing set of
edges $E =  \{\{i,j\}, \dots \}$, returns one of the nodes in $E$ with the least number of edges. It returns a new set of edges $\{\{i,j\}, \dots \}$ with all edges added by the small-world topology.

The implementation first arranges the cliques of $DC$ in a list, which
represents the ring. Traversing the list with increasing indices is equivalent
to traversing the ring in the clockwise direction, and inversely. Then, for every clique $i$ on the ring from which we are computing the distance to others, a number of edges are added. All other cliques are implicitly arranged in mutually exclusive sets, with size and at offset exponentially bigger (doubling at every step). Then for every of these sets, $ns$ edges are added, both in the clockwise and counter-clockwise directions, always on the nodes with the least number of edges in each clique. The ring edges are implicitly added to the cliques at offset $1$ in both directions.
 
 % \section{Additional Experiments}

% \subsection{Effect of Clique Averaging and Uniform Initialization}

% Section~\ref{section:clique-averaging} explained how Clique Averaging reduces bias and showed that Clique Averaging was significantly beneficial on MNIST with fully-connected D-Cliques. In this section, we provide additional results for the ring topology, as well as for CIFAR10. In addition, during our early exploration, we noticed that ensuring \textit{uniform initialization}, i.e. ensuring that all nodes start with the same model, increased convergence speed when connecting two cliques with 1-2 interclique edges. We therefore also verify whether this effect is still significant with 10 cliques (100 nodes), on a ring and with full connections between cliques, as well as on MNIST and CIFAR10. We also verified what interaction this had with Clique Averaging.

% Figure~\ref{fig:d-cliques-mnist-init-clique-avg-effect} shows all the results for MNIST. Comparing Figure~\ref{fig:d-cliques-mnist-init-clique-avg-effect-ring-test-accuracy} to~\ref{fig:d-cliques-mnist-no-init-clique-avg-effect-ring-test-accuracy}, and Figure~\ref{fig:d-cliques-mnist-init-clique-avg-effect-fcc-test-accuracy} to~\ref{fig:d-cliques-mnist-no-init-clique-avg-effect-fcc-test-accuracy} together, we see that Uniform Initialization has imperceptible effects. However, for all four sub-figures, using Clique Averaging has a slightly better average convergence speed, and significantly lower variance between nodes, than not using it. Moreover, the improvement is larger with Fully-Connected D-Cliques.

% \begin{figure}[htbp]
%      \centering
%       % To regenerate the figure, from directory results/mnist   
%       % python ../../../learn-topology/tools/plot_convergence.py clique-ring/all/2021-03-10-18:14:35-CET no-clique-avg/clique-ring/all/2021-03-12-10:40:37-CET --add-min-max --yaxis test-accuracy --labels 'with clique avg.' 'without clique avg.' --legend 'lower right' --ymin 85 --ymax 92.5 --save-figure ../../figures/d-cliques-mnist-init-clique-avg-effect-ring-test-accuracy.png
%       \begin{subfigure}[b]{0.48\textwidth}
%          \centering
%          \includegraphics[width=\textwidth]{figures/d-cliques-mnist-init-clique-avg-effect-ring-test-accuracy}
%          \caption{\label{fig:d-cliques-mnist-init-clique-avg-effect-ring-test-accuracy} D-Cliques (Ring), with Uniform Initialization}
%      \end{subfigure}
%      \quad 
%      % To regenerate the figure, from directory results/mnist
%      % python ../../../learn-topology/tools/plot_convergence.py no-init/clique-ring/all/2021-03-12-10:40:11-CET no-init-no-clique-avg/clique-ring/all/2021-03-12-10:41:03-CET --add-min-max --yaxis test-accuracy --labels 'with clique avg.' 'without clique avg.' --legend 'lower right' --ymin 85 --ymax 92.5 --save-figure ../../figures/d-cliques-mnist-no-init-clique-avg-effect-ring-test-accuracy.png   
%       \begin{subfigure}[b]{0.48\textwidth}
%          \centering
%          \includegraphics[width=\textwidth]{figures/d-cliques-mnist-no-init-clique-avg-effect-ring-test-accuracy}
%          \caption{\label{fig:d-cliques-mnist-no-init-clique-avg-effect-ring-test-accuracy} D-Cliques (Ring), without Uniform Initialization}
%      \end{subfigure}
     
%      % To regenerate the figure, from directory results/mnist
%      %python ../../../learn-topology/tools/plot_convergence.py fully-connected-cliques/all/2021-03-10-10:19:44-CET no-clique-avg/fully-connected-cliques/all/2021-03-12-11:12:26-CET --add-min-max --yaxis test-accuracy --labels 'with clique avg.'    'without clique avg.'  --legend 'lower right' --ymin 85 --ymax 92.5 --save-figure ../../figures/d-cliques-mnist-init-clique-avg-effect-fcc-test-accuracy.png
%        \begin{subfigure}[b]{0.48\textwidth}
%          \centering
%          \includegraphics[width=\textwidth]{figures/d-cliques-mnist-init-clique-avg-effect-fcc-test-accuracy}
%          \caption{\label{fig:d-cliques-mnist-init-clique-avg-effect-fcc-test-accuracy} D-Cliques (Fully-Connected), with Uniform Initialization}
%      \end{subfigure}
%      \quad
%       % To regenerate the figure, from directory results/mnist
%      %python ../../../learn-topology/tools/plot_convergence.py no-init/fully-connected-cliques/all/2021-03-12-11:12:01-CET no-init-no-clique-avg/fully-connected-cliques/all/2021-03-12-11:12:49-CET --add-min-max --yaxis test-accuracy --labels 'with clique avg.' 'without clique avg.' --legend 'lower right' --ymin 85 --ymax 92.5 --save-figure ../../figures/d-cliques-mnist-no-init-clique-avg-effect-fcc-test-accuracy.png
%        \begin{subfigure}[b]{0.48\textwidth}
%          \centering
%          \includegraphics[width=\textwidth]{figures/d-cliques-mnist-no-init-clique-avg-effect-fcc-test-accuracy}
%          \caption{\label{fig:d-cliques-mnist-no-init-clique-avg-effect-fcc-test-accuracy} D-Cliques (Fully-Connected), without Uniform Initialization}
%      \end{subfigure}
     
     
% \caption{\label{fig:d-cliques-mnist-init-clique-avg-effect} MNIST: Effects of Clique Averaging and Uniform Initialization on Convergence Speed. (100 nodes, non-IID, D-Cliques, bsz=128)}
% \end{figure}

% Figure~\ref{fig:d-cliques-cifar10-init-clique-avg-effect} shows all the results for CIFAR10. One the one hand, with D-Cliques arranged in a ring, uniform initialization has a small but positive effect on convergence speed, whether Clique Averaging is used or not. With fully-connected D-Cliques,  the effect is significantly smaller and almost negligible, both with and without Clique Averaging. On the other hand, Clique Averaging is always beneficial, by a significantly larger margin for both interclique topologies and with and without uniform initialization. Moreover, the effect is stronger than for MNIST.

%     \begin{figure}[htbp]
%      \centering
%      % To regenerate the figure, from directory results/cifar10
%      % python ../../../learn-topology/tools/plot_convergence.py clique-ring/all/2021-03-10-11:58:43-CET no-init/clique-ring/all/2021-03-13-18:28:30-CET no-clique-avg/clique-ring/all/2021-03-13-18:27:09-CET  no-init-no-clique-avg/clique-ring/all/2021-03-13-18:29:58-CET --add-min-max --yaxis test-accuracy --labels 'with clique avg., with uniform init.' 'with clique avg., without uniform init.'  'without clique avg., with uniform init.'   'without clique avg., without uniform init.' --legend 'upper left' --ymax 115  --save-figure ../../figures/d-cliques-cifar10-init-clique-avg-effect-ring-test-accuracy.png --font-size 15
%       \begin{subfigure}[b]{0.48\textwidth}
%          \centering
%          \includegraphics[width=\textwidth]{figures/d-cliques-cifar10-init-clique-avg-effect-ring-test-accuracy}
%          \caption{\label{fig:d-cliques-cifar10-init-clique-avg-effect-ring-test-accuracy} D-Cliques (Ring)}
%      \end{subfigure}
%      % To regenerate the figure, from directory results/cifar10
%      %python ../../../learn-topology/tools/plot_convergence.py fully-connected-cliques/all/2021-03-10-13:58:57-CET no-init/fully-connected-cliques/all/2021-03-13-18:32:55-CET no-clique-avg/fully-connected-cliques/all/2021-03-13-18:31:36-CET  no-init-no-clique-avg/fully-connected-cliques/all/2021-03-13-18:34:35-CET --add-min-max --yaxis test-accuracy --labels 'with clique avg., with uniform init.' 'with clique avg., without uniform init.'  'without clique avg., with uniform init.'   'without clique avg., without uniform init.' --legend 'upper left'  --ymax 115 --save-figure ../../figures/d-cliques-cifar10-init-clique-avg-effect-fcc-test-accuracy.png --font-size 15
%        \begin{subfigure}[b]{0.48\textwidth}
%          \centering
%          \includegraphics[width=\textwidth]{figures/d-cliques-cifar10-init-clique-avg-effect-fcc-test-accuracy}
%          \caption{\label{fig:d-cliques-cifar10-init-clique-avg-effect-fcc-test-accuracy} D-Cliques (Fully-Connected)}
%      \end{subfigure}
% \caption{\label{fig:d-cliques-cifar10-init-clique-avg-effect} CIFAR10: Effects of Clique Averaging and Uniform Initialization on Convergence Speed. (100 nodes, non-IID, D-Cliques, bsz=20, momentum=0.9)}
% \end{figure}

% We conclude that Uniform Initialization is not so important for convergence speed but that Clique Averaging is always significantly so.

% \subsection{Comparison to Non-Clustered Topologies}    
%     
%     \begin{figure}
%\centering
%              \begin{subfigure}[htb]{0.48\textwidth}
%% To regenerate the figure, from directory results/mnist/gn-lenet
%% python ../../../../learn-topology/tools/plot_convergence.py no-init/all/2021-03-22-21:39:54-CET no-init-no-clique-avg/all/2021-03-22-21:40:16-CET random-10/all/2021-03-22-21:41:06-CET random-10-diverse/all/2021-03-22-21:41:46-CET random-10-diverse-unbiased-grad/all/2021-03-22-21:42:04-CET --legend 'lower right' --add-min-max --labels 'd-clique (fcc) clique avg.' 'd-clique (fcc) no clique avg.' '10 random edges' '10 random edges (all classes repr.)' '10 random edges (all classes repr.) with unbiased grad.' --ymin 80 --yaxis test-accuracy --save-figure ../../../figures/d-cliques-mnist-lenet-comparison-to-non-clustered-topologies.png
%         \includegraphics[width=\textwidth]{figures/d-cliques-mnist-lenet-comparison-to-non-clustered-topologies}
%         \caption{\label{fig:d-cliques-mnist-lenet-comparison-to-non-clustered-topologies} LeNet Model}
%        \end{subfigure}
%        \hfill
%                      \begin{subfigure}[htb]{0.48\textwidth}
%% To regenerate the figure, from directory results/mnist/gn-lenet
%% python ../../../../learn-topology/tools/plot_convergence.py no-init/all/2021-03-22-21:39:54-CET no-init-no-clique-avg/all/2021-03-22-21:40:16-CET random-10/all/2021-03-22-21:41:06-CET random-10-diverse/all/2021-03-22-21:41:46-CET random-10-diverse-unbiased-grad/all/2021-03-22-21:42:04-CET --legend 'upper right' --add-min-max --labels 'd-clique (fcc) clique avg.' 'd-clique (fcc) no clique avg.' '10 random edges' '10 random edges (all classes repr.)' '10 random edges (all classes repr.) with unbiased grad.' --ymax 0.7 --yaxis scattering --save-figure ../../../figures/d-cliques-mnist-lenet-comparison-to-non-clustered-topologies-scattering.png
%         \includegraphics[width=\textwidth]{figures/d-cliques-mnist-lenet-comparison-to-non-clustered-topologies-scattering}
%         \caption{\label{fig:d-cliques-mnist-lenet-comparison-to-non-clustered-topologies-scattering} LeNet Model (Scattering)}
%        \end{subfigure}
%       
%         \caption{\label{fig:d-cliques-mnist-comparison-to-non-clustered-topologies} MNIST: Comparison to non-Clustered Topologies}
%\end{figure}
%
% \begin{figure}
% \centering
%     % To regenerate the figure, from directory results/cifar10
%% python ../../../learn-topology/tools/plot_convergence.py fully-connected-cliques/all/2021-03-10-13:58:57-CET no-init-no-clique-avg/fully-connected-cliques/all/2021-03-13-18:34:35-CET  random-10/all/2021-03-17-20:30:03-CET  random-10-diverse/all/2021-03-17-20:30:41-CET random-10-diverse-unbiased-gradient/all/2021-03-17-20:31:14-CET random-10-diverse-unbiased-gradient-uniform-init/all/2021-03-17-20:31:41-CET --labels 'd-clique (fcc) clique avg., uniform init.' 'd-clique (fcc) no clique avg. no uniform init.' '10 random edges' '10 random edges (all classes repr.)' '10 random (all classes repr.) with unbiased grad.' '10 random (all classes repr.) with unbiased grad., uniform init.' --add-min-max --legend 'upper right' --yaxis scattering --save-figure ../../figures/d-cliques-cifar10-linear-comparison-to-non-clustered-topologies-scattering.png --ymax 0.7
%        \begin{subfigure}[b]{0.48\textwidth}
%        \centering
%         \includegraphics[width=\textwidth]{figures/d-cliques-cifar10-linear-comparison-to-non-clustered-topologies-scattering}
%         \caption{\label{fig:d-cliques-cifar10-linear-comparison-to-non-clustered-topologies-scattering} LeNet Model: Scattering}
%     \end{subfigure}  
%         
%\caption{\label{fig:d-cliques-cifar10-linear-comparison-to-non-clustered-topologies} CIFAR10: Comparison to non-Clustered Topologies}
%\end{figure} 
%
%
%\begin{itemize}
%  \item Clustering does not seem to make a difference in MNIST, even when using a higher-capacity model (LeNet) instead of a linear model. (Fig.\ref{fig:d-cliques-mnist-comparison-to-non-clustered-topologies})     
%  \item Except for the random 10 topology, convergence speed seems to be correlated with scattering in CIFAR-10 with LeNet model (Fig.\ref{fig:d-cliques-cifar10-linear-comparison-to-non-clustered-topologies}). There is also more difference between topologies both in convergence speed and scattering than for MNIST (Fig.~\ref{fig:d-cliques-mnist-comparison-to-non-clustered-topologies}). Scattering computed similar to Consensus Control for Decentralized Deep Learning~\cite{consensus_distance}.
%\end{itemize}
%
%

% \clearpage

\section{Additional Experiments on Scaling Behavior with Increasing Number of
Nodes}
\label{app:scaling}

Section~\ref{section:scaling} compares the convergence speed of various inter-clique topologies at a scale of 1000 nodes. In this section, we show the effect of scaling the number of nodes, by comparing the convergence speed with 1, 10, 100, and 1000 nodes, and adjusting the batch size to maintain a constant number of updates per epoch. We present results for Ring, Fractal, Small-world, and Fully-Connected inter-clique topologies.
 
Figure~\ref{fig:d-cliques-mnist-scaling-fully-connected} shows the results for
MNIST. For all topologies, we notice a perfect scaling up to 100 nodes, i.e.
the accuracy curves overlap, with low variance between nodes. Starting at 1000
nodes, there is a significant increase in variance between nodes and the
convergence is slower, only marginally for Fully-Connected but
significantly so for Fractal and Ring. Small-world has higher variance between nodes but maintains a convergence speed close to that of Fully-Connected.


% MNIST
% all/2021-10-12-03:00:24-CEST-labostrex116 all/2021-10-11-17:38:20-CEST-labostrex118 all/2021-09-28-23:18:49-CEST-labostrex119 all/2021-09-29-22:12:31-CEST-labostrex112


\begin{figure}[htbp]
         \centering     
              % To regenerate the figure, from directory results-v2
              % python $TOOLS/analyze/filter.py all/ --nodes:name 2-shards-uneq-classes --topology:interclique-topology smallworld --nodes:nb-nodes 100 1000 --meta:seed 1 | python $TOOLS/analyze/diff.py
               % python $TOOLS/analyze/diff.py --rundirs  all/2021-10-12-03:00:24-CEST-labostrex116 all/2021-10-11-17:38:20-CEST-labostrex118 all/2021-09-28-23:18:49-CEST-labostrex119 all/2021-09-29-22:12:31-CEST-labostrex112 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels '1 node bsz=12800' '10 nodes bsz=1280' '100 nodes bsz=128' '1000 nodes bsz=13' --ymax 92.5 --ymin 80 --yaxis test-accuracy --save-figure '../mlsys2022style/figures/d-cliques-mnist-scaling-fully-connected-cst-updates.png' --font-size 18 --linewidth 3 --linestyles 'solid' 'dashed'  'dotted' 'dashdot'
      \begin{subfigure}[b]{0.35\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-mnist-scaling-fully-connected-cst-updates}
         \caption{Fully-Connected}
     \end{subfigure}
     \quad
       % To regenerate the figure, from directory results-v2
       % python $TOOLS/analyze/filter.py all/ --nodes:name 2-shards-uneq-classes --topology:interclique-topology smallworld --nodes:nb-nodes 100 1000 --meta:seed 1 | python $TOOLS/analyze/diff.py
       % python $TOOLS/analyze/diff.py --rundirs  all/2021-10-12-03:00:24-CEST-labostrex116 all/2021-10-11-17:38:20-CEST-labostrex118 all/2021-10-13-13:54:20-CEST-labostrex114  all/2021-09-30-11:40:59-CEST-labostrex116 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels '1 node bsz=12800' '10 nodes bsz=1280' '100 nodes bsz=128' '1000 nodes bsz=13' --ymax 92.5 --ymin 80 --yaxis test-accuracy --save-figure '../mlsys2022style/figures/d-cliques-mnist-scaling-smallworld-cst-updates.png' --font-size 18 --linewidth 3 --linestyles 'solid' 'dashed'  'dotted' 'dashdot'
      \begin{subfigure}[b]{0.35\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-mnist-scaling-smallworld-cst-updates}
         \caption{Small-world}
     \end{subfigure}
     \quad

          % To regenerate the figure, from directory results-v2
          % python $TOOLS/analyze/filter.py all/ --nodes:name 2-shards-uneq-classes --topology:interclique-topology fractal --nodes:nb-nodes 100 1000 --meta:seed 1 | python $TOOLS/analyze/diff.py
       % python $TOOLS/analyze/diff.py --rundirs  all/2021-10-12-03:00:24-CEST-labostrex116 all/2021-10-11-17:38:20-CEST-labostrex118 all/2021-10-13-13:48:08-CEST-labostrex112 all/2021-09-30-11:39:47-CEST-labostrex114 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels '1 node bsz=12800' '10 nodes bsz=1280' '100 nodes bsz=128' '1000 nodes bsz=13' --ymax 92.5 --ymin 80 --yaxis test-accuracy --save-figure '../mlsys2022style/figures/d-cliques-mnist-scaling-fractal-cliques-cst-updates.png' --font-size 18 --linewidth 3 --linestyles 'solid' 'dashed'  'dotted' 'dashdot'
         \begin{subfigure}[b]{0.35\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-mnist-scaling-fractal-cliques-cst-updates}
         \caption{Fractal}
     \end{subfigure}  
     \quad
     % To regenerate the figure, from directory results-v2
     % python $TOOLS/analyze/filter.py all/ --nodes:name 2-shards-uneq-classes --topology:interclique-topology ring --nodes:nb-nodes 100 1000 --meta:seed 1 | python $TOOLS/analyze/diff.py
       % python $TOOLS/analyze/diff.py --rundirs  all/2021-10-12-03:00:24-CEST-labostrex116 all/2021-10-11-17:38:20-CEST-labostrex118 all/2021-10-13-13:53:50-CEST-labostrex113 all/2021-09-30-11:40:32-CEST-labostrex115 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels '1 node bsz=12800' '10 nodes bsz=1280' '100 nodes bsz=128' '1000 nodes bsz=13' --ymax 92.5 --ymin 80 --yaxis test-accuracy --save-figure '../mlsys2022style/figures/d-cliques-mnist-scaling-ring-cliques-cst-updates.png' --font-size 18 --linewidth 3 --linestyles 'solid' 'dashed'  'dotted' 'dashdot'
         \begin{subfigure}[b]{0.35\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-mnist-scaling-ring-cliques-cst-updates}
         \caption{Ring}
     \end{subfigure}  
     
     \caption{\label{fig:d-cliques-mnist-scaling-fully-connected} MNIST:
     D-Cliques scaling behavior (constant updates per epoch and 10 nodes per clique) for different
     inter-clique topologies.} 
\end{figure}
     
Figure~\ref{fig:d-cliques-cifar10-scaling-fully-connected} shows the results
for CIFAR10. When increasing from 1 to 10 nodes (resulting in a single
fully-connected clique), there is actually a small increase both in final
accuracy and convergence speed. We believe this increase is due to the
gradient being computed with better representation of examples from all
classes with 10 fully-connected non-IID nodes, while the gradient for a single
non-IID node may have a slightly larger bias because the random sampling 
may allow more bias in the representation of classes in each batch. At a
scale of 100 nodes, there is no difference between Fully-Connected and
Fractal, as the connections are the same; however, a Ring already shows a
significantly slower convergence. At 1000 nodes, the convergence significantly
slows down for Fractal and Ring, while remaining close, albeit with a larger
variance, to Fully-Connected. Similar to MNIST, Small-world has
higher variance and slightly lower convergence speed than Fully-Connected but
remains very close.

We therefore conclude that Fully-Connected and Small-world have good scaling
properties in terms of convergence speed, and that the
linear-logarithmic number of edges of Small-world makes it the best compromise
between convergence speed and connectivity, and thus the best choice for
efficient large-scale decentralized learning in practice.

%  python $TOOLS/analyze/filter.py all/ --nodes:name 2-shards-eq-classes  --nodes:nb-nodes 1 10 100 1000 --meta:seed 1 | python $TOOLS/analyze/diff.py

\begin{figure}[htbp]
         \centering
     % To regenerate the figure, from directory results-v2
     % python $TOOLS/analyze/filter.py all/ --nodes:name 2-shards-eq-classes --topology:interclique-topology fully-connected --nodes:nb-nodes 100 1000 --meta:seed 1 | python $TOOLS/analyze/diff.py
       % python $TOOLS/analyze/diff.py --rundirs all/2021-10-11-19:57:35-CEST-labostrex116 all/2021-10-11-19:39:08-CEST-labostrex117 all/2021-10-03-19:53:21-CEST-labostrex117 all/2021-10-05-19:38:01-CEST-labostrex114 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels  '1 node IID bsz=2000' '10 nodes non-IID bsz=200' '100 nodes non-IID bsz=20' '1000 nodes non-IID bsz=2' --yaxis test-accuracy --save-figure '../mlsys2022style/figures/d-cliques-cifar10-scaling-fully-connected-cst-updates.png' --font-size 18 --linewidth 3 --linestyles 'solid' 'dashed'  'dotted' 'dashdot'
      \begin{subfigure}[b]{0.35\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-cifar10-scaling-fully-connected-cst-updates}
         \caption{Fully-Connected}
     \end{subfigure}
     \quad
     % To regenerate the figure, from directory results-v2
     % python $TOOLS/analyze/filter.py all/ --nodes:name 2-shards-eq-classes --topology:interclique-topology smallworld --nodes:nb-nodes 100 1000 --meta:seed 1 | python $TOOLS/analyze/diff.py
       % python $TOOLS/analyze/diff.py --rundirs all/2021-10-11-19:57:35-CEST-labostrex116 all/2021-10-11-19:39:08-CEST-labostrex117 all/2021-10-13-13:56:16-CEST-labostrex117 all/2021-10-05-19:40:04-CEST-labostrex117 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels  '1 node IID bsz=2000' '10 nodes non-IID bsz=200' '100 nodes non-IID bsz=20' '1000 nodes non-IID bsz=2' --yaxis test-accuracy --save-figure '../mlsys2022style/figures/d-cliques-cifar10-scaling-smallworld-cst-updates.png' --font-size 18 --linewidth 3 --linestyles 'solid' 'dashed'  'dotted' 'dashdot'
      \begin{subfigure}[b]{0.35\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-cifar10-scaling-smallworld-cst-updates}
         \caption{Small-world}
     \end{subfigure}
     
     
     % To regenerate the figure, from directory results-v2
     % python $TOOLS/analyze/filter.py all/ --nodes:name 2-shards-eq-classes --topology:interclique-topology fractal --nodes:nb-nodes 100 1000 --meta:seed 1 | python $TOOLS/analyze/diff.py
       % python $TOOLS/analyze/diff.py --rundirs all/2021-10-11-19:57:35-CEST-labostrex116 all/2021-10-11-19:39:08-CEST-labostrex117 all/2021-10-13-13:55:42-CEST-labostrex115 all/2021-10-05-19:39:26-CEST-labostrex116 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels  '1 node IID bsz=2000' '10 nodes non-IID bsz=200' '100 nodes non-IID bsz=20' '1000 nodes non-IID bsz=2' --yaxis test-accuracy --save-figure '../mlsys2022style/figures/d-cliques-cifar10-scaling-fractal-cst-updates.png' --font-size 18 --linewidth 3 --linestyles 'solid' 'dashed'  'dotted' 'dashdot'
         \begin{subfigure}[b]{0.35\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-cifar10-scaling-fractal-cst-updates}
         \caption{Fractal}
     \end{subfigure}  
     \quad

     % To regenerate the figure, from directory results-v2
     % python $TOOLS/analyze/filter.py all/ --nodes:name 2-shards-eq-classes --topology:interclique-topology ring --nodes:nb-nodes 100 1000 --meta:seed 1 | python $TOOLS/analyze/diff.py
       % python $TOOLS/analyze/diff.py --rundirs all/2021-10-11-19:57:35-CEST-labostrex116 all/2021-10-11-19:39:08-CEST-labostrex117 all/2021-10-13-13:56:00-CEST-labostrex116 all/2021-10-05-19:40:41-CEST-labostrex119 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --labels  '1 node IID bsz=2000' '10 nodes non-IID bsz=200' '100 nodes non-IID bsz=20' '1000 nodes non-IID bsz=2' --yaxis test-accuracy --save-figure '../mlsys2022style/figures/d-cliques-cifar10-scaling-ring-cst-updates.png' --font-size 18 --linewidth 3 --linestyles 'solid' 'dashed'  'dotted' 'dashdot'
         \begin{subfigure}[b]{0.35\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-cifar10-scaling-ring-cst-updates}
         \caption{Ring}
     \end{subfigure}  
     
     \caption{\label{fig:d-cliques-cifar10-scaling-fully-connected} CIFAR10: D-Cliques scaling behavior (constant updates per epoch and 10 nodes per clique) for different
     inter-clique topologies.} 
\end{figure}

\section{Additional Experiments with Extreme Label Skew}
\label{app:extreme-local-skew} 

In this section, we present additional results for similar experiments as in
Section~\ref{section:evaluation} but in the presence of
 \textit{extreme label distribution skew}: we consider that each node only has examples from a single class. This extreme partitioning case provides an upper bound on the effect of label distribution skew suggesting that D-Cliques should perform similarly or better in less extreme cases, as long as a small-enough average skew can be obtained on all cliques. In turn, this helps to provide insights on why D-Cliques work well, as well as to quantify the loss in convergence speed
that may result from using construction algorithms that generate cliques with higher skew.

\subsection{Data Heterogeneity Assumptions}
\label{section:non-iid-assumptions}

To isolate the effect of label distribution skew from other potentially compounding
factors, we make the following simplifying assumptions: (1) All classes are
equally represented in the global dataset; (2) All classes are represented on
the same number of nodes; (3) All nodes have the same number of examples.

While less realistic than the assumptions used Section~\ref{section:evaluation}, 
these assumptions are still reasonable because: (1) Global class imbalance equally
affects the optimization process on a single node and is therefore not
specific to the decentralized setting; (2) Our results do not exploit specific
positions in the topology;  (3) Imbalanced dataset sizes across nodes can be
addressed for instance by appropriately weighting the individual loss
functions.

These assumptions do make the construction of cliques slightly easier by 
making it easy to build cliques that have zero skew, as shown in 
Section~\ref{section:ideal-cliques}. 

\subsection{Constructing Ideal Cliques}
\label{section:ideal-cliques}
 
 Algorithm~\ref{Algorithm:D-Clique-Construction} shows the overall approach
 for constructing a D-Cliques topology under the assumptions of Section~\ref{section:non-iid-assumptions}.\footnote{An IID
 version of D-Cliques, in which each node has an equal number of examples of
 all classes, can be implemented by picking $\#L$ nodes per clique at random.}
 It expects the following inputs: $L$, the set of all classes present in the global distribution $D = \bigcup_{i \in N} D_i$; $N$, the set of all nodes; a function $classes(S)$, which given a subset $S$ of nodes in $N$ returns the set of classes in their joint local distributions ($D_S = \bigcup_{i \in S} D_i$); a function $intra(DC)$, which given $DC$, a set of cliques (set of set of nodes), creates a set of edges ($\{\{i,j\}, \dots \}$) connecting all nodes within each clique to one another; a function $inter(DC)$, which given a set of cliques, creates a set of edges ($\{\{i,j\}, \dots \}$) connecting nodes belonging to different cliques; and a function $weigths(E)$, which given a set of edges, returns the weighted matrix $W_{ij}$.  Algorithm~\ref{Algorithm:D-Clique-Construction} returns both $W_{ij}$, for use in D-SGD (Algorithm~\ref{Algorithm:D-PSGD} and~\ref{Algorithm:Clique-Unbiased-D-PSGD}), and $DC$, for use with Clique Averaging (Algorithm~\ref{Algorithm:Clique-Unbiased-D-PSGD}).
 
   \begin{figure}[h]
   \hrule
   \begin{algorithmic}[1]
        \State \textbf{Require:} set of classes globally present $L$, 
        \State~~ set of all nodes $N = \{ 1, 2, \dots, n \}$,
        \State~~ fn $\textit{classes}(S)$ that returns the classes present in a subset of nodes $S$,
        \State~~ fn $\textit{intra}(DC)$ that returns edges intraconnecting cliques of $DC$,
        \State~~ fn $\textit{inter}(DC)$ that returns edges interconnecting cliques of $DC$ (Sec.~\ref{section:interclique-topologies})
         \State~~ fn $\textit{weights}(E)$ that assigns weights to edges in $E$ 
         
        \State $R \leftarrow \{ n~\text{for}~n \in N \}$ \Comment{Remaining nodes}
        \State $DC \leftarrow \emptyset$ \Comment{D-Cliques}
        \State $\textit{C} \leftarrow \emptyset$ \Comment{Current Clique}
        \While{$R \neq \emptyset$}
       \State $n \leftarrow \text{pick}~1~\text{from}~\{ m \in R | \textit{classes}(\{m\}) \subsetneq \textit{classes}(\textit{C}) \}$
       \State $R \leftarrow R \setminus \{ n \}$
       \State $C \leftarrow C \cup \{ n \}$
       \If{$\textit{classes}(C) = L$}
           \State $DC \leftarrow DC \cup \{ C \}$
           \State $C \leftarrow \emptyset$
       \EndIf
        \EndWhile
        \State \Return $(weights(\textit{intra}(DC) \cup \textit{inter}(DC)), DC)$
   \end{algorithmic}
   \hrule
   \caption{D-Cliques Construction}
   \label{Algorithm:D-Clique-Construction}
\end{figure}
 
The implementation builds a single clique by adding nodes with different
classes until all classes of the global distribution are represented. Each
clique is built sequentially until all nodes are parts of cliques.
Because all classes are represented on an equal number of nodes, all cliques
will have nodes of all classes. Furthermore, since nodes have examples
of a single class, we are guaranteed a valid assignment is possible in a greedy manner. 
After cliques are created, edges are added and weights are assigned to edges, 
using the corresponding input functions.

\subsection{Evaluation}
\label{section:ideal-cliques-evaluation}

In this section, we provide figures analogous to those of the main text using the partitioning 
scheme of Section~\ref{section:non-iid-assumptions}.

\subsubsection{Data Heterogeneity is Significant at Multiple Levels of Node Skew} 

\autoref{fig:iid-vs-non-iid-problem-1-class-per-node} is consistent  with \autoref{fig:iid-vs-non-iid-problem} albeit
with slower convergence speed and higher variance.  On the one hand, \autoref{fig:iid-vs-non-iid-problem-1-class-per-node} shows that an extreme  skew amplifies the difficulty of learning. On the other hand, \autoref{fig:iid-vs-non-iid-problem} shows that the problem is not limited to the most extreme cases and is therefore worthy of consideration in designing decentralized federated learning solutions.

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name ring grid fully-connected --nodes:name iid-uneq-classes 2-shards-uneq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py

% Ring
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-12:31:37-CEST-labostrex112 all/2021-09-28-12:34:14-CEST-labostrex115  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 92.5 --yaxis test-accuracy --labels '100 nodes homogeneous' '100 nodes skewed' --save-figure ../mlsys2022style/figures/ring-IID-vs-non-IID-eq-classes-1-class-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3
% Grid
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-12:33:12-CEST-labostrex113 all/2021-09-28-12:38:21-CEST-labostrex116  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 92.5 --yaxis test-accuracy --labels '100 nodes homogeneous' '100 nodes skewed' --save-figure ../mlsys2022style/figures/grid-IID-vs-non-IID-eq-classes-1-class-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3
% Fully-Connected
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-12:33:25-CEST-labostrex114 all/2021-09-28-12:39:00-CEST-labostrex117   --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 92.5 --yaxis test-accuracy --labels '100 nodes homogeneous' '100 nodes skewed' --save-figure ../mlsys2022style/figures/fc-IID-vs-non-IID-eq-classes-1-class-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3

\begin{figure*}[htbp]
     \centering
     \begin{subfigure}[b]{0.25\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/ring-IID-vs-non-IID-eq-classes-1-class-per-node}
\caption{\label{fig:ring-IID-vs-non-IID-eq-classes-1-class-per-node} Ring topology}
     \end{subfigure}
     \quad
     \begin{subfigure}[b]{0.25\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/grid-IID-vs-non-IID-eq-classes-1-class-per-node}
\caption{\label{fig:grid-IID-vs-non-IID-eq-classes-1-class-per-node} Grid topology}
     \end{subfigure}
     \quad
     \begin{subfigure}[b]{0.25\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/fc-IID-vs-non-IID-eq-classes-1-class-per-node}
\caption{\label{fig:fully-connected-IID-vs-non-IID-eq-classes-1-class-per-node} Fully-connected topology}
     \end{subfigure}
        \caption{Convergence speed of decentralized SGD with and without label distribution skew for different topologies on MNIST (Variation of \autoref{fig:iid-vs-non-iid-problem} using balanced classes and skewed with 1 class/node).
        \label{fig:iid-vs-non-iid-problem-1-class-per-node}}
\end{figure*}

\subsubsection{D-Cliques Match the Convergence Speed of Fully-Connected with a Fraction of the Edges}

\autoref{fig:convergence-speed-dc-vs-fc-1-class-per-node} shows consistent
results with \autoref{fig:convergence-speed-dc-vs-fc-2-shards-per-node}:
D-Cliques work equally well in more extreme skew. It should therefore work
well for other levels of label distribution skew commonly encountered in
practice.

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name fully-connected d-cliques/ideal --nodes:name max-local-skew --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-12:39:00-CEST-labostrex117 all/2021-09-28-23:18:40-CEST-labostrex118 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 80 --ymax 92.5 --yaxis test-accuracy --labels 'fully-connected' 'd-cliques (fc) w/ cliq-avg' --save-figure ../mlsys2022style/figures/convergence-speed-mnist-dc-fc-vs-fc-1-class-per-node.png --linestyles 'solid' 'dashed' --linewidth 3
% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name fully-connected d-cliques/ideal --nodes:name max-local-skew --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-16:09:21-CEST-labostrex112 all/2021-10-03-19:45:14-CEST-labostrex118 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 100 --yaxis test-accuracy --labels 'fully-connected' 'd-cliques (fc) w/ cliq-avg' --save-figure ../mlsys2022style/figures/convergence-speed-cifar10-dc-fc-vs-fc-1-class-per-node.png --linestyles 'solid' 'dashed' --legend 'lower right' --linewidth 3

\begin{figure}[htbp]
    \centering        
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-mnist-dc-fc-vs-fc-1-class-per-node}
    \caption{\label{fig:convergence-speed-mnist-dc-fc-vs-fc-1-class-per-node} MNIST}
    \end{subfigure}
    \hfill
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-cifar10-dc-fc-vs-fc-1-class-per-node}
    \caption{\label{fig:convergence-speed-cifar10-dc-fc-vs-fc-1-class-per-node} CIFAR10 (with momentum)}
    \end{subfigure}
\caption{\label{fig:convergence-speed-dc-vs-fc-1-class-per-node} Comparison on 100 heterogeneous nodes
between a fully-connected network and D-Cliques (fully-connected) constructed with Greedy Swap (10 cliques of 10 nodes) using
Clique Averaging. (Variation of \autoref{fig:convergence-speed-dc-vs-fc-2-shards-per-node} with 1 class/node instead of 2 shards/node).}
\end{figure}

\subsubsection{Clique Averaging and Momentum are Beneficial and Sometimes Necessary}

\autoref{fig:d-clique-mnist-clique-avg-1-class-per-node} and \autoref{fig:cifar10-c-avg-momentum-1-class-per-node} show that, compared respectively to \autoref{fig:d-clique-mnist-clique-avg} and \autoref{fig:cifar10-c-avg-momentum}, Clique Averaging increases in importance the more extreme the skew is and provides consistent convergence speed at multiple levels.

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name d-cliques/ideal --nodes:name max-local-skew --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-23:18:40-CEST-labostrex118  all/2021-09-29-03:52:47-CEST-labostrex118 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 89 --ymax 92.5 --yaxis test-accuracy --labels 'd-cliques (fc) w/ c-avg.'  'd-cliques (fc) w/o c-avg.' --save-figure ../mlsys2022style/figures/convergence-speed-mnist-dc-no-c-avg-vs-c-avg-1-class-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 2.5
\begin{figure}[htbp]
         \centering
         \includegraphics[width=0.23\textwidth]{figures/convergence-speed-mnist-dc-no-c-avg-vs-c-avg-1-class-per-node}
\caption{\label{fig:d-clique-mnist-clique-avg-1-class-per-node} MNIST: Effect of Clique Averaging on D-Cliques (fully-connected) with 10 cliques of 10 heterogeneous nodes (100 nodes). Y axis starts at 89. (Variation of \autoref{fig:d-clique-mnist-clique-avg} with balanced classes and 1 class/node instead of 2 shards/node).}
\end{figure}

% CIFAR10
%  python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name d-cliques/greedy-swap --nodes:name 2-shards-eq-classes --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% w/o Clique Averaging
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-04-02:50:28-CEST-labostrex118 all/2021-10-03-23:22:09-CEST-labostrex118  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 100 --yaxis test-accuracy --labels 'd-cliques (fc) w/ momentum' 'd-cliques (fc) w/o momentum'  --save-figure ../mlsys2022style/figures/convergence-speed-cifar10-wo-c-avg-no-mom-vs-mom-1-class-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3
% w/ Clique Averaging
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-19:45:14-CEST-labostrex118 all/2021-10-03-16:11:33-CEST-labostrex118  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 100 --yaxis test-accuracy --labels 'd-cliques (fc) w/ momentum' 'd-cliques (fc) w/o momentum'  --save-figure ../mlsys2022style/figures/convergence-speed-cifar10-w-c-avg-no-mom-vs-mom-1-class-per-node.png --linestyles 'solid' 'dashed' --font-size 18 --linewidth 3 --legend 'lower right'
\begin{figure}[htbp]
    \centering        
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-cifar10-wo-c-avg-no-mom-vs-mom-1-class-per-node}
    \caption{\label{fig:convergence-speed-cifar10-wo-c-avg-no-mom-vs-mom-1-class-per-node} Without Clique Averaging }
    \end{subfigure}
    \hfill
    \begin{subfigure}[b]{0.23\textwidth}
    \centering
    \includegraphics[width=\textwidth]{figures/convergence-speed-cifar10-w-c-avg-no-mom-vs-mom-1-class-per-node}
    \caption{\label{fig:convergence-speed-cifar10-w-c-avg-no-mom-vs-mom-1-class-per-node} With Clique Averaging}
    \end{subfigure}
\caption{\label{fig:cifar10-c-avg-momentum-1-class-per-node} CIFAR10: Effect of Clique Averaging, without and with
momentum, on D-Cliques (fully-connected) with 10 cliques of 10 heterogeneous nodes (100 nodes) (variation of \autoref{fig:cifar10-c-avg-momentum} with 1 class/node instead of 2 shards/node).}
\end{figure}

\subsubsection{D-Cliques Clustering is Necessary}
\label{section:d-cliques-clustering-is-necessary}

In this experiment, we compare D-Cliques to different variations of random graphs,
with additional variations compared to the experiments of Section~\ref{section:d-cliques-vs-random-graphs}, 
to show it is actually necessary. Compared to a random graph, D-Cliques enforce additional constraints 
and provide additional mechanisms: they ensure
a diverse representation of all classes in the immediate neighbourhood of all nodes; they enable
 Clique Averaging to debias gradients; and they provide a high-level of clustering, i.e. neighbors 
 of a node are neighbors themselves, which tends to lower variance.
In order to distinguish the effect of the first two from the last, we compare D-Cliques to other variations 
of random graphs: (1) with the additional constraint that all classes should be represented in the immediate neighborhood of all nodes 
(i.e. 'diverse neighbors'), and (2) in combination with unbiased gradients computed using 
the average of the gradients of a subset of neighbors of a node such that the skew of that subset is 0.

The partitioning scheme we use (Section~\ref{section:non-iid-assumptions}) makes the construction of both D-Cliques and diverse random graphs easy and ensures that in both cases the skew of the cliques or neighborhood subset is exactly 0. This removes the challenge of designing topology optimization algorithms for both D-Cliques and random graphs that would guarantee reaching the same level of skews in both cases to make results comparable.

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name random-graph d-cliques/ideal greedy-diverse-random  --nodes:name max-local-skew --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-23:18:40-CEST-labostrex118 all/2021-09-29-03:52:47-CEST-labostrex118 all/2021-09-29-22:17:30-CEST-labostrex119 all/2021-10-11-18:32:25-CEST-labostrex113 all/2021-10-13-10:05:42-CEST-labostrex112 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 80 --ymax 100 --yaxis test-accuracy --labels 'd-cliques (fc) w/ cliq-avg'  'd-cliques (fc) w/o cliq-avg'  'random 10' 'random 10 (diverse neighbors)' 'random 10 (diverse neighbors) unbiased'  --save-figure ../mlsys2022style/figures/convergence-mnist-random-vs-d-cliques-1-class-per-node.png --linestyles 'solid' 'dashed' 'dotted' 'dashdot' 'solid' --markers '' '' '' '' 'o' --font-size 13 --linewidth 3

% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name random-graph d-cliques/ideal greedy-diverse-random  --nodes:name max-local-skew  --nodes:nb-nodes 100 --algorithm:learning-momentum 0.9  | python $TOOLS/analyze/diff.py
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-19:45:14-CEST-labostrex118 all/2021-10-04-02:50:28-CEST-labostrex118 all/2021-10-06-12:20:34-CEST-labostrex113 all/2021-10-12-02:54:13-CEST-labostrex112 all/2021-10-11-17:01:15-CEST-labostrex112 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 119 --yaxis test-accuracy --labels 'd-cliques (fc) w/ cliq-avg'  'd-cliques (fc) w/o cliq-avg'  'random 10' 'random 10 (diverse neighbors)'  'random 10 (diverse neighbors) unbiased'  --save-figure ../mlsys2022style/figures/convergence-cifar10-random-vs-d-cliques-1-class-per-node.png --linestyles 'solid' 'dashed' 'dotted' 'dashdot' 'solid' --markers '' '' '' '' 'o'  --font-size 13 --linewidth 3

\begin{figure}[htbp]
     \centering     
         \begin{subfigure}[b]{0.23\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/convergence-mnist-random-vs-d-cliques-1-class-per-node}
                  \caption{MNIST}
         \end{subfigure}
                 \hfill                      
        \begin{subfigure}[b]{0.23\textwidth}
        \centering
         \includegraphics[width=\textwidth]{figures/convergence-cifar10-random-vs-d-cliques-1-class-per-node}
         \caption{CIFAR10}
     \end{subfigure} 
 \caption{\label{fig:convergence-random-vs-d-cliques-1-class-per-node} Comparison to variations of Random Graph with 10 edges per node on 100 nodes (variation of \autoref{fig:convergence-random-vs-d-cliques-2-shards} with 1 class/node instead of 2 shards/node as well as additional random graphs with more constraints).} 
\end{figure}

\autoref{fig:convergence-random-vs-d-cliques-1-class-per-node} compares the convergence speed of D-Cliques with all the variations of random graphs on both MNIST and CIFAR10. In both cases,
D-Cliques converge faster than all other options. In addition, in the case of CIFAR10, the clustering appears to be critical
for good convergence speed: even a random graph with diverse neighborhoods and unbiased gradients 
converges significantly slower.

%We demonstrate the advantages of D-Cliques over alternative sparse topologies
%that have a similar number of edges. First, we consider topologies in which
%the neighbors of each node are selected at random (hence without any clique
%structure).
%Specifically, for $n=100$ nodes, we
%construct a random topology such that each node has exactly 10 edges, which is
%similar to the average 9.9 edges of our D-Cliques topology 
%(Figure~\ref{fig:d-cliques-figure}). To better understand the role of
%the clique structure beyond merely ensuring class representativity among
%neighbors,
%we also compare to a random topology similar to the one described above except
%that edges are
%chosen such that each node has neighbors of all possible classes. Finally, we
%also implement an analog of Clique Averaging for these random topologies,
%where all nodes de-bias their gradient based on the class distribution of
%their neighbors. In the latter case, since nodes do not form a clique, each
%node obtains a different average gradient.
%
%The results for MNIST and CIFAR10 are shown in
%Figure~\ref{fig:d-cliques-comparison-to-non-clustered-topologies}. For MNIST,
%a purely random topology has higher variance and lower convergence speed than
%D-Cliques (with or without Clique Averaging), while a random topology with
%class representativity performs similarly as D-Cliques without Clique
%Averaging. However and perhaps surprisingly, a random topology with unbiased
%gradient performs slightly worse than without it. In any case, D-Cliques with
%Clique Averaging outperforms all random topologies, showing that the clique
%structure has a small but noticeable effect on the average accuracy and
%significantly reduces the variance across nodes in this setup.
%
%\begin{figure}[t]
%     \centering     
%         \begin{subfigure}[b]{0.35\textwidth}
%         \centering
%         \includegraphics[width=\textwidth]{../figures/d-cliques-mnist-linear-comparison-to-non-clustered-topologies}
%                  \caption{MNIST with Linear Model}
%         \end{subfigure}
%                 \hfill                      
%        \begin{subfigure}[b]{0.35\textwidth}
%        \centering
%         \includegraphics[width=\textwidth]{../figures/d-cliques-cifar10-linear-comparison-to-non-clustered-topologies}
%         \caption{CIFAR10 with LeNet}
%     \end{subfigure} 
% \caption{\label{fig:d-cliques-comparison-to-non-clustered-topologies} Comparison to Non-Clustered Topologies} 
%\end{figure}
%
%On the harder CIFAR10 dataset with a deep convolutional network, the
%differences are much more dramatic:
%D-Cliques with Clique Averaging and momentum turns out to be critical for fast
%convergence.
%Crucially, all random topologies fail to converge to a good solution. This
%confirms that our clique structure is important to reduce variance
%across nodes and improve the convergence. The difference with the previous
%experiment seems to be due to both the use of a higher capacity model and to
%the intrinsic characteristics of the datasets.




\subsubsection{D-Cliques Scale with Sparser Inter-Clique Topologies}

\autoref{fig:d-cliques-scaling-mnist-1000-1-class-per-node} and \autoref{fig:d-cliques-scaling-cifar10-1000-1-class-per-node} are consistent with \autoref{fig:d-cliques-scaling-mnist-1000} and \autoref{fig:d-cliques-scaling-cifar10-1000}. The less extreme skew enables a slightly faster convergence rate in the case of CIFAR10 (\autoref{fig:d-cliques-scaling-cifar10-1000}).

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name d-cliques/ideal fully-connected --nodes:name max-local-skew iid-eq-classes --meta:seed 1 --nodes:nb-nodes 1000 1 | python $TOOLS/analyze/diff.py
% Linear
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-12:39:00-CEST-labostrex117 all/2021-09-30-11:41:26-CEST-labostrex117 all/2021-09-30-11:41:37-CEST-labostrex118  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 84 --ymax 92.5 --yaxis test-accuracy  --labels 'fully-connected (100 nodes)' 'd-cliques (fractal)' 'd-cliques (ring)' --save-figure ../mlsys2022style/figures/d-cliques-scaling-mnist-1000-linear-1-class-per-node.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
% Super-Linear
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-12:39:00-CEST-labostrex117 all/2021-09-29-22:12:47-CEST-labostrex113 all/2021-09-30-11:41:50-CEST-labostrex119   --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 84 --ymax 92.5 --yaxis test-accuracy  --labels 'fully-connected (100 nodes)' 'd-cliques (fully-connected)' 'd-cliques (smallworld)' --save-figure ../mlsys2022style/figures/d-cliques-scaling-mnist-1000-super-linear-1-class-per-node.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3

\begin{figure}[htbp]
     \centering
     \begin{subfigure}[b]{0.23\textwidth}
         \centering
            \includegraphics[width=\textwidth]{figures/d-cliques-scaling-mnist-1000-linear-1-class-per-node}
             \caption{\label{fig:d-cliques-scaling-mnist-1000-linear-1-class-per-node} Linear}
     \end{subfigure}
     \hfill
     \begin{subfigure}[b]{0.23\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-scaling-mnist-1000-super-linear-1-class-per-node}
\caption{\label{fig:d-cliques-scaling-mnist-1000-super-linear-1-class-per-node}  Super- and Quasi-Linear}
     \end{subfigure}
\caption{\label{fig:d-cliques-scaling-mnist-1000-1-class-per-node} MNIST: D-Cliques convergence speed with 1000 nodes (10 nodes per clique, same number of updates per epoch as 100 nodes, i.e. batch-size 10x less per node) with different inter-clique topologies. (variation of \autoref{fig:d-cliques-scaling-mnist-1000} with 1 class/node instead of 2 shards/node).}
\end{figure}

% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --topology:name d-cliques/ideal fully-connected --nodes:name max-local-skew iid-eq-classes --meta:seed 1 --nodes:nb-nodes 1000 1 --algorithm:batch-size 2 2000 | python $TOOLS/analyze/diff.py
% Linear
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-16:09:21-CEST-labostrex112  all/2021-10-06-20:10:56-CEST-labostrex116 all/2021-10-06-13:59:44-CEST-labostrex119 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 80 --yaxis test-accuracy  --labels 'fully-connected (100 nodes)' 'd-cliques (fractal)' 'd-cliques (ring)' --save-figure ../mlsys2022style/figures/d-cliques-scaling-cifar10-1000-linear-1-class-per-node.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
% Super-Linear
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-16:09:21-CEST-labostrex112 all/2021-10-06-23:55:52-CEST-labostrex114 all/2021-10-06-15:22:30-CEST-labostrex117 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 80 --yaxis test-accuracy  --labels 'fully-connected (100 nodes)' 'd-cliques (fully-connected)' 'd-cliques (smallworld)' --save-figure ../mlsys2022style/figures/d-cliques-scaling-cifar10-1000-super-linear-1-class-per-node.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
\begin{figure}[htbp]
     \centering
     \begin{subfigure}[b]{0.23\textwidth}
         \centering
            \includegraphics[width=\textwidth]{figures/d-cliques-scaling-cifar10-1000-linear-1-class-per-node}
             \caption{\label{fig:d-cliques-scaling-cifar10-1000-linear-1-class-per-node} Linear}
     \end{subfigure}
     \hfill
     \begin{subfigure}[b]{0.23\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-scaling-cifar10-1000-super-linear-1-class-per-node}
\caption{\label{fig:d-cliques-scaling-cifar10-1000-super-linear-1-class-per-node}  Super- and Quasi-Linear}
     \end{subfigure}
\caption{\label{fig:d-cliques-scaling-cifar10-1000-1-class-per-node} CIFAR10: D-Cliques convergence speed with 1000 nodes (10 nodes per clique, same number of updates per epoch as 100 nodes, i.e. batch-size 10x less per node) with different inter-clique topologies (variation of \autoref{fig:d-cliques-scaling-cifar10-1000} with 1 class/node instead of 2 shards/node).}
\end{figure}

\subsubsection{Full Intra-Clique Connectivity is Necessary}

% From directory 'results-v2':
% MNIST
% python $TOOLS/analyze/filter.py all --dataset:name mnist --topology:name d-cliques/ideal --nodes:name max-local-skew --meta:seed 1 --nodes:nb-nodes 100 | python $TOOLS/analyze/diff.py

% w/o Clique Gradient
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-29-03:52:47-CEST-labostrex118 all/2021-10-02-21:26:18-CEST-labostrex113 all/2021-10-03-06:33:52-CEST-labostrex113 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 89 --ymax 92.5 --yaxis test-accuracy --labels 'full intra-connectivity' '-1 edge/clique' '-5 edges/clique' --save-figure ../mlsys2022style/figures/d-cliques-ideal-wo-clique-avg-impact-of-edge-removal.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
% w/ Clique Gradient
% python $TOOLS/analyze/diff.py --rundirs all/2021-09-28-23:18:40-CEST-labostrex118 all/2021-10-02-16:50:53-CEST-labostrex113  all/2021-10-03-02:00:23-CEST-labostrex113 --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 89 --ymax 92.5 --yaxis test-accuracy  --labels 'full intra-connectivity' '-1 edge/clique' '-5 edges/clique' --save-figure ../mlsys2022style/figures/d-cliques-ideal-w-clique-avg-impact-of-edge-removal.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3

\begin{figure}[htbp]
     \centering
\begin{subfigure}[htbp]{0.23\textwidth}
     \centering   
         \includegraphics[width=\textwidth]{figures/d-cliques-ideal-wo-clique-avg-impact-of-edge-removal}     
\caption{\label{fig:d-cliques-ideal-wo-clique-avg-impact-of-edge-removal} Without Clique Averaging }
\end{subfigure}
\hfill
\begin{subfigure}[htbp]{0.23\textwidth}
     \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-ideal-w-clique-avg-impact-of-edge-removal}
\caption{\label{fig:d-cliques-ideal-w-clique-avg-impact-of-edge-removal} With Clique Averaging}
\end{subfigure}
\caption{\label{fig:d-cliques-ideal-mnist-intra-connectivity} MNIST: Impact of intra-clique edge removal on D-Cliques (fully-connected) with 10 cliques of 10 heterogeneous nodes (100 nodes) (variation of \autoref{fig:d-cliques-mnist-intra-connectivity} with 1 class/node instead of 2 shards/node). Y axis starts at 89.}
\end{figure}

\autoref{fig:d-cliques-ideal-mnist-intra-connectivity} and \autoref{fig:d-cliques-ideal-cifar10-intra-connectivity} show higher variance than \autoref{fig:d-cliques-mnist-intra-connectivity} and \autoref{fig:d-cliques-cifar10-intra-connectivity}, with a significantly lower convergence speed in the case of CIFAR10 (\autoref{fig:d-cliques-ideal-cifar10-intra-connectivity}).



% CIFAR10
% python $TOOLS/analyze/filter.py all --dataset:name cifar10 --nodes:name max-local-skew --meta:seed 1 --nodes:nb-nodes 100 --topology:name d-cliques/ideal --algorithm:learning-momentum 0.9 | python $TOOLS/analyze/diff.py
% w/o Clique Gradient
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-04-02:50:28-CEST-labostrex118 all/2021-10-06-16:42:25-CEST-labostrex118 all/2021-10-07-07:05:11-CEST-labostrex118  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 80 --yaxis test-accuracy --labels 'full intra-connectivity' '-1 edge/clique' '-5 edges/clique' --save-figure ../mlsys2022style/figures/d-cliques-ideal-cifar10-wo-clique-avg-impact-of-edge-removal.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3
% w/ Clique Gradient
% python $TOOLS/analyze/diff.py --rundirs all/2021-10-03-19:45:14-CEST-labostrex118 all/2021-10-06-12:58:34-CEST-labostrex118 all/2021-10-07-03:22:44-CEST-labostrex118  --pass-through | python $TOOLS/plot/convergence.py --add-min-max --ymin 0 --ymax 80 --yaxis test-accuracy --labels 'full intra-connectivity' '-1 edge/clique' '-5 edges/clique' --save-figure ../mlsys2022style/figures/d-cliques-ideal-cifar10-w-clique-avg-impact-of-edge-removal.png --linestyles 'solid' 'dashed' 'dotted' --font-size 18 --linewidth 3

\begin{figure}[t]
     \centering
\begin{subfigure}[htbp]{0.23\textwidth}
     \centering   
         \includegraphics[width=\textwidth]{figures/d-cliques-ideal-cifar10-wo-clique-avg-impact-of-edge-removal}     
\caption{\label{fig:d-cliques-ideal-cifar10-wo-clique-avg-impact-of-edge-removal} Without Clique Averaging }
\end{subfigure}
\hfill
\begin{subfigure}[htbp]{0.23\textwidth}
     \centering
         \includegraphics[width=\textwidth]{figures/d-cliques-ideal-cifar10-w-clique-avg-impact-of-edge-removal}
\caption{\label{fig:d-cliques-ideal-cifar10-w-clique-avg-impact-of-edge-removal} With Clique Averaging}
\end{subfigure}
\caption{\label{fig:d-cliques-ideal-cifar10-intra-connectivity} CIFAR10: Impact of intra-clique edge removal (with momentum) on D-Cliques (fully-connected) with 10 cliques of 10 heterogeneous nodes (100 nodes) (variation of \autoref{fig:d-cliques-cifar10-intra-connectivity} with 1 class/node instead of 2 shards/node).}
\end{figure}
     
 